%integra
% A simple integration application
% LAST UPDATED by Andy French. January 2014.

function varargout = integra(varargin)

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @integra_OpeningFcn, ...
    'gui_OutputFcn',  @integra_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

%%

function integra_OpeningFcn(hObject, eventdata, handles, varargin)

% Choose default command line output for integra
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

global d
%Load d from previous settings
try
    load settings
    
    %Update the GUI with settings data
    set( handles.EDITeqa1,'string',d.eqa1 );
    set( handles.EDITeqa2,'string',d.eqa2 );
    set( handles.CHECKeqa1,'value',d.eqa1_show );
    set( handles.CHECKeqa2,'value',d.eqa2_show );
    set( handles.CHECKshowarea,'value',d.area_show );
    set( handles.EDITa,'string',num2str(d.a) );
    set( handles.EDITb,'string',num2str(d.b) );
    set( handles.CHECKshowresult,'value',d.result_show );
    set( handles.EDITxmin,'string',num2str( d.xmin )) ;
    set( handles.EDITymin,'string',num2str( d.ymin )) ;
    set( handles.EDITxmax,'string',num2str( d.xmax )) ;
    set( handles.EDITymax,'string',num2str( d.ymax )) ;
    set( handles.EDITxtick,'string',num2str( d.xtick )) ;
    set( handles.EDITytick,'string',num2str( d.ytick )) ;
    set( handles.CHECKxyscale,'value',d.xyscale );
end
handles = guidata(gcf);
d.h = handles;
gui_update;

%%

%Equation 1 edit box callback
function EDITeqa1_Callback(hObject, eventdata, handles)
gui_update

%%

%Equation 2 edit box callback
function EDITeqa2_Callback(hObject, eventdata, handles)
gui_update

%%

%Lower limit of integral edit box
function EDITa_Callback(hObject, eventdata, handles)
gui_update

%%

%Upper limit of integral edit box
function EDITb_Callback(hObject, eventdata, handles)
gui_update

%%

%Show integral area check box
function CHECKshowarea_Callback(hObject, eventdata, handles)
gui_update

%%

%Show integration result checkbox
function CHECKshowresult_Callback(hObject, eventdata, handles)
gui_update

%%

%Equation 1 check box callback
function CHECKeqa1_Callback(hObject, eventdata, handles)
gui_update

%%

%Equation 2 check box callback
function CHECKeqa2_Callback(hObject, eventdata, handles)
gui_update

%%

% y axis maximum edit box callback
function EDITymax_Callback(hObject, eventdata, handles)
gui_update

%%

% y axis minimum edit box callback
function EDITymin_Callback(hObject, eventdata, handles)
gui_update

%%

% x axis minimum edit box callback
function EDITxmin_Callback(hObject, eventdata, handles)
gui_update

%%

% x axis maximum edit box callback
function EDITxmax_Callback(hObject, eventdata, handles)
gui_update

%%

% xtick edit box callback
function EDITxtick_Callback(hObject, eventdata, handles)
gui_update

%%

% ytick edit box callback
function EDITytick_Callback(hObject, eventdata, handles)
gui_update

%%

% x,y equal scales checkbox callback
function CHECKxyscale_Callback(hObject, eventdata, handles)
gui_update

%%

% Print PNG pushbutton
function PUSHprintPNG_Callback(hObject, eventdata, handles)
fig = figure;
plot_graph;
print(fig,['integra ',strrep(datestr(now),':','-')],'-djpeg','-r300');
close(fig);

%%

function varargout = integra_OutputFcn(hObject, eventdata, handles)

%%

% GUI update function
function gui_update
global d

%%% Inputs %%%

%Set number of data points
d.N = 1000;

%Set label font sizes
d.fsize = 20;

%

%Get parameters from GUI
d.eqa1 = get( d.h.EDITeqa1,'string' );
d.eqa2 = get( d.h.EDITeqa2,'string' );
d.a = str2num( get( d.h.EDITa,'string' ));
d.b = str2num( get( d.h.EDITb,'string' ));
d.eqa1_show = get( d.h.CHECKeqa1,'value' );
d.eqa2_show = get( d.h.CHECKeqa2,'value' );
d.area_show = get( d.h.CHECKshowarea,'value' );
d.result_show = get( d.h.CHECKshowresult,'value' );
d.xmin = str2num( get( d.h.EDITxmin,'string') );
d.ymin = str2num( get( d.h.EDITymin,'string') );
d.xmax = str2num( get( d.h.EDITxmax,'string') );
d.ymax = str2num( get( d.h.EDITymax,'string') );
d.xtick = str2num( get( d.h.EDITxtick,'string') );
d.ytick = str2num( get( d.h.EDITytick,'string') );
d.xyscale = get( d.h.CHECKxyscale,'value' );

%Create x data
x = linspace(d.xmin,d.xmax,d.N);
d.x = x;

%Generate y data for each equation.
s1 = sort_out_fx(get( d.h.EDITeqa1,'string' ));
eval(s1);
d.y1 = imag_check(y);
s2 = sort_out_fx(get( d.h.EDITeqa2,'string' ));
eval(s2);
d.y2 = imag_check(y);

%Determine patch x,y coordinates for integration area
x = linspace( d.a, d.b, d.N );
eval(s1);
y1 = imag_check(y);
eval(s2);
y2 = imag_check(y);
d.y_int_patch = [ y1, fliplr(y2) ];
d.x_int_patch = [x,fliplr(x)];

%Integrate equations 1 and 2 between limits
[d.I1,d.a,d.b] = integrate( x, y1, d.a, d.b );
[d.I2,d.a,d.b] = integrate( x, y2, d.a, d.b );
d.I = d.I1 - d.I2;

%Update limits if badly set
set( d.h.EDITa,'string',num2str(d.a) );
set( d.h.EDITb,'string',num2str(d.b) );

%Update integration result edit box
if ( d.result_show == 1 )
    set( d.h.EDITresult, 'string', num2str( d.I ) );
else
    set( d.h.EDITresult, 'string', '' );
end

%Check if d.y_int_patch contains any NaN characters. If so make patch empty
%as the integral between curves f(x) and g(x) is undefined.
if sum(isnan(d.y_int_patch))~=0
    d.x_int_patch = [];
    d.y_int_patch = [];
end

%Plot graphs
axes(d.h.AXESgraph);
cla;
plot_graph;

%Save settings
save settings d

%%

%Plot graph function
function plot_graph
global d

%Plot integration area patch
if ( d.area_show == 1 )
    d.int_patch = patch( d.x_int_patch, d.y_int_patch, 'g' );
    set( d.int_patch, 'facecolor',[0,1,0],'edgecolor',[0,1,0] );
    alpha(0.5);
end
hold on

%Plot equations
p=plot( d.x, d.y1, 'r','linewidth',2 );
if d.eqa1_show == 0; delete(p); end
hold on
if d.eqa2_show == 1; plot( d.x, d.y2, 'b','linewidth',2  ); end

%Plot x and y axis
plot( [d.xmin,d.xmax],[0,0],'k','linewidth',3 )
plot( [0,0], [d.ymin,d.ymax],'k','linewidth',3 )

%Set equi-spaced grid and fix limits
if d.xyscale==1
    axis equal
else
    axis auto
end
set(d.h.AXESgraph,'fontsize',d.fsize);
xlim( [d.xmin,d.xmax] );
ylim( [d.ymin,d.ymax] );
xlabel('x','fontsize',d.fsize)
ylabel('y','fontsize',d.fsize)

%Determine tick marks for grid
yticks = roundn(d.ymin,1) : roundn(d.ytick,1) : roundn(d.ymax,1);
xticks = roundn(d.xmin,1) : roundn(d.xtick,1) : roundn(d.xmax,1);
set( gca, 'xtick',xticks,'ytick',yticks );
grid on

%%

%Sort out a valid f(x) or g(x) from string s
function s = sort_out_fx(s)

%Check for blank inputs, or constant inputs.
if isempty(s)==1
    s = 'y=0*x';
elseif isempty( strfind( s, 'x' ) ) == 1
    s = [s,'*ones(size(x))']; 
end

%Force element-wise multiplication (since x is a vector)
s = strrep(s,'^','.^');
s = strrep(s,'/','./');
s = strrep(s,'*','.*');
s = [s,';'];

%%

%Round to n decimal places
function x = roundn(x,n)
x = x*10^n;
x = round(x);
x = x*10^-n;

%%

%Definite integral function. Integrated y(x) between limits a and b.
%If limits are outside the range of [a,b] then the nearest limit of vector
%x is given, which must be increasing. b > a is assumed.
function [I,a,b] = integrate( x, y, a, b )

%Check and fix limits of integration
if a < min(x); a = min(x); end
if b > max(x); b = max(x); end

%Check if y has any NaN values. Return NaN if this is the case
if sum(isnan(y))~=0
    I = NaN;
else
    %Integrate using cubic splines
    [Y_pp,Ib] = calculus(x,y,b,'integ','spline',0);
    [Y_pp,Ia] = calculus(x,y,a,'integ','spline',0);
    I = Ib - Ia;
end

%%

%Set values to be NaN if imaginary parts detected
function y = imag_check(x)
im_tol = 1e-6;
ok = find( ( abs( imag(x) ) < im_tol ) );
y = NaN(size(x));
y(ok) = real( x(ok) );

%End of code

